<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: COM_OrdenItemClasificacion.xml */
/* Generado: 2020-08-18 04:21:25 */

/* Mantenimiento de los registros de la tabla COM_OrdenItemClasificacion */
abstract class BaseCOM_OrdenItemClasificacionDP extends COM_OrdenItemClasificacionBV
{
    /* Constructor ( Establece los valores desde un objeto COM_OrdenItemClasificacionBN ) */
    public function __construct( COM_OrdenItemClasificacionBN $o_COM_OrdenItemClasificacionBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_COM_OrdenItemClasificacionBN ) )
        {
            $this->setByBN( $o_COM_OrdenItemClasificacionBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto COM_OrdenItemClasificacionBN */
    public function setByBN( COM_OrdenItemClasificacionBN $o_COM_OrdenItemClasificacionBN )
    {
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdOrdenClasificacion() ) )
        {
            $this->setIdOrdenClasificacion( $o_COM_OrdenItemClasificacionBN->getIdOrdenClasificacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_COM_OrdenItemClasificacionBN->getIdCompania() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getCodigoSunat() ) )
        {
            $this->setCodigoSunat( $o_COM_OrdenItemClasificacionBN->getCodigoSunat() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getNombreCompania() ) )
        {
            $this->setNombreCompania( $o_COM_OrdenItemClasificacionBN->getNombreCompania() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdItemTipo() ) )
        {
            $this->setIdItemTipo( $o_COM_OrdenItemClasificacionBN->getIdItemTipo() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_COM_OrdenItemClasificacionBN->getDescripcion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_COM_OrdenItemClasificacionBN->getIdAlmacen() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getEstado() ) )
        {
            $this->setEstado( $o_COM_OrdenItemClasificacionBN->getEstado() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_COM_OrdenItemClasificacionBN->getFechaCreacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_COM_OrdenItemClasificacionBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_COM_OrdenItemClasificacionBN->getFechaModificacion() );
        }
        if ( !is_null( $o_COM_OrdenItemClasificacionBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_COM_OrdenItemClasificacionBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_COM_OrdenItemClasificacionFN = new COM_OrdenItemClasificacionFN();
        $o_COM_OrdenItemClasificacionBN = $o_COM_OrdenItemClasificacionFN->selectByPk( $this->getIdOrdenClasificacion() );
        if ( is_null( $o_COM_OrdenItemClasificacionBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO COM_OrdenItemClasificacion ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdOrdenClasificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdOrdenClasificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdOrdenClasificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoSunat";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreCompania";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreCompania()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItemTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItemTipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItemTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE COM_OrdenItemClasificacion SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoSunat = '".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreCompania = '".$this->getNombreCompania()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItemTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItemTipo = '".$this->getIdItemTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdOrdenClasificacion = '".$this->getIdOrdenClasificacion()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM COM_OrdenItemClasificacion WHERE  IdOrdenClasificacion = '".$this->getIdOrdenClasificacion()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>